﻿    BuildModel/model={name='LeNet', replace=1} type = "CNN";
    run;
 
    /* input layer */
    AddLayer/model='LeNet' name="mnist" 
             layer={type='input' nchannels=1 width=28 height=28 scale=0.00392156862745098039};
    run;
 
    /* conv1 layer: 20*5*5 */
    AddLayer/model='LeNet' name="conv1" 
            layer={type='convolution' nFilters=20 width=5 height=5 stride=1 init="XAVIER" act="IDENTITY"} srcLayers={"mnist"};
    run;

    /* conv1 batch normalization */
    AddLayer/model='LeNet' name="conv1_bn"
            layer={type='batchnorm' act='RELU'} srcLayers={"conv1"};
    run;
 
    /* pool1 layer: 2*2 */
    AddLayer/model='LeNet' name="pool1" 
            layer={type='pooling' width=2 height=2 stride=2 pool='max'} srcLayers={"conv1_bn"};
    run;
 
    /* conv2 layer: 50*5*5 */
    AddLayer/model='LeNet' name="conv2" 
             layer={type='convolution' nFilters=50 width=5 height=5 stride=1 init="XAVIER" act="IDENTITY"} srcLayers={"pool1"};
    run;
 
    /* conv2 batch normalization */
    AddLayer/model='LeNet' name="conv2_bn"
            layer={type='batchnorm' act='RELU'} srcLayers={"conv2"};
    run;

    /* pool2 layer: 2*2 */
    AddLayer/model='LeNet' name="pool2" 
         layer={type='pooling' width=2 height=2 stride=2 pool='max'} srcLayers={"conv2_bn"};
    run;
 
    /* fc layer: 500 */
    AddLayer/model='LeNet' name="ip1"
             layer={type='fullconnect' n=500 act='relu' init="XAVIER"} srcLayers={"pool2"};
    run;

    /* fc layer: 10 */
    AddLayer/model='LeNet' name="ip2"
             layer={type='output' n=10 act='softmax' init="XAVIER"} srcLayers={"ip1"};
    run;
